package jp.sf.amateras.builder;

import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResourceDelta;
import org.eclipse.core.resources.IncrementalProjectBuilder;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;

public class XMLBuilder extends IncrementalProjectBuilder {
	
	public static final String BUILDER_ID = "jp.sf.amateras.builder.XMLBuilder";
	
	protected IProject[] build(int kind, Map args, IProgressMonitor monitor)
			throws CoreException {
		
		if (kind == FULL_BUILD) {
			fullBuild(monitor);
		} else {
			IResourceDelta delta = getDelta(getProject());
			if (delta == null) {
				fullBuild(monitor);
			} else {
				incrementalBuild(delta, monitor);
			}
		}
		return null;
	}
	
	/** trh */
	private void fullBuild(IProgressMonitor monitor){
		try {
			getProject().accept(new XMLResourceVisitor());
		} catch (CoreException e) {
			e.printStackTrace();
		}
	}
	
	/** CN^rh */
	private void incrementalBuild(IResourceDelta delta, IProgressMonitor monitor){
		try {
			delta.accept(new XMLDeltaVisitor());
		} catch (CoreException e) {
			e.printStackTrace();
		}
	}
}
